import socket
from dnslib.server import DNSServer, DNSLogger, BaseResolver
from dnslib import DNSRecord, QTYPE

class MyResolver(BaseResolver):
    def resolve(self, request, handler):
        qname = str(request.q.qname)
        qtype = request.q.qtype

        try:
            # انتخاب یک سرور DNS معتبر برای جستجو
            dns_server = "8.8.8.8"
            dns_port = 53

            # ارسال پرس و جو به سرور DNS
            with socket.socket(socket.AF_INET, socket.SOCK_DGRAM) as s:
                s.connect((dns_server, dns_port))
                s.sendall(request.pack())
                response_data = s.recv(1024)

            # پردازش جواب دریافتی
            response = DNSRecord.parse(response_data)
            reply = request.reply()
            for rdata in response.rr:
                reply.add_answer(rdata)
            return reply
        except Exception as e:
            print(f"An error occurred: {e}")
            return None

def main():
    resolver = MyResolver()
    logger = DNSLogger(prefix=False)
    logger.log_reply = lambda *args, **kwargs: None
    server = DNSServer(resolver, port=53, address="0.0.0.0", logger=logger)
    print("YaraiT.Com DNS Sniffer Started...")
    try:
        server.start()
    except KeyboardInterrupt:
        server.stop()

if __name__ == "__main__":
    main()